Package com.netrics.likeit

## Class NetricsCmdStats

- java.lang.Object
- - com.netrics.likeit.NetricsCmdStats

- All Implemented Interfaces:
    `java.io.Serializable`

      public class NetricsCmdStats
      extends java.lang.Object
      implements java.io.Serializable

  This class contains summary statistics form the server on usage of a particular command.
  A summary report on the number of commands processed, minimum, maximum, total and average processing time can be obtained from ibi™ Patterns - Search. This class is used to contain the report for one command.
  Note that "command" as used here are commands from the server's point of view. This may not correspond to calls from the Java API. Normally a number of different API calls will map to the same server command. A static list of server command names is provided with this class.
  Time values are reported in milliseconds since an arbitrary epic point. They can't be correlated with with real time clock values. Negative values mean a time was not reported.
  Durations are reported in milliseconds. Negative values means a duration was not reported.
  Three types of timing values are reported:
  Full time is the time from when the command request was first received by the server until writing of the response was completed.
  Processing time is the time taken to actually perform the actions associated with the command.
  Overhead time is the difference between Full and Processing time. It includes any time spent waiting for a worker thread to become available and the time spent reading and writing the response. (An exception to this is the commands that read records, where the time spent reading the records is included in Processing time.)
  Objects of this class are generated as the results of a NetricsServerInterface.cmdstats call, they can not be created directly.
  See Also:
    `NetricsServerInterface.cmdstats(String[],double,double)`, Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `CMD_ALL` | Special "command" that means all commands.
    `static java.lang.String` | `CMD_CHARMAP_CREATE` | The Character Map Create command.
    `static java.lang.String` | `CMD_CHARMAP_LIST` | The Character Map List command.
    `static java.lang.String` | `CMD_CHPT_STATS` | Return information on last checkpoint (internal cmd only).
    `static java.lang.String` | `CMD_GATEWAY_CONFIG` | Reload gateway configuration.
    `static java.lang.String` | `CMD_IDX_LIST` | The index list command (for partitioned indexes).
    `static java.lang.String` | `CMD_MODEL_CREATE` | The Learning Model create/load command.
    `static java.lang.String` | `CMD_MODEL_DELETE` | The Learning Model delete command.
    `static java.lang.String` | `CMD_MODEL_EVALUATE` | The Learning Model evaluate command.
    `static java.lang.String` | `CMD_MODEL_LIST` | The Learning Model list command.
    `static java.lang.String` | `CMD_REC_ADD` | The record add command.
    `static java.lang.String` | `CMD_REC_DELETE` | The record delete command.
    `static java.lang.String` | `CMD_REC_GET` | The record get command.
    `static java.lang.String` | `CMD_REC_RECNEXT` | Retrieve the next record from the table.
    `static java.lang.String` | `CMD_REC_REPLACE` | The record replace command.
    `static java.lang.String` | `CMD_REC_UPDATE` | The record update command.
    `static java.lang.String` | `CMD_SCORE_RECORDS` | Compute match score for a set of records.
    `static java.lang.String` | `CMD_SEARCH` | The search (query) command.
    `static java.lang.String` | `CMD_SVR_CMDSTATS` | The fetch command statistics command.
    `static java.lang.String` | `CMD_SVR_LOGOFF` | The server turn Query logging off command.
    `static java.lang.String` | `CMD_SVR_LOGON` | The server turn Query logging on command.
    `static java.lang.String` | `CMD_SVR_NOOP` | The server No-Op (do nothing) command.
    `static java.lang.String` | `CMD_SVR_SHUTDOWN` | The server shutdown command.
    `static java.lang.String` | `CMD_SVR_VERSION` | The fetch server version info command.
    `static java.lang.String` | `CMD_TBL_CHECKPOINT` | The table checkpoint command.
    `static java.lang.String` | `CMD_TBL_DELETE` | The table delete command.
    `static java.lang.String` | `CMD_TBL_LIST` | The table list (table statistics) command.
    `static java.lang.String` | `CMD_TBL_LOAD` | The table load command.
    `static java.lang.String` | `CMD_TBL_MOVE` | The table move (rename) command.
    `static java.lang.String` | `CMD_TBL_RESTORE` | The table restore command.
    `static java.lang.String` | `CMD_THESAURUS_CREATE` | The thesaurus create command (includes weighted dict and combined).
    `static java.lang.String` | `CMD_THESAURUS_DELETE` | The thesaurus delete command (includes weighted dict and combined).
    `static java.lang.String` | `CMD_THESAURUS_LIST` | The thesaurus list command (includes weighted dict and combined).
    `static java.lang.String` | `CMD_TRAN_ABORT` | Abort an explicit transaction.
    `static java.lang.String` | `CMD_TRAN_COMMIT` | Commit an explicit transaction.
    `static java.lang.String` | `CMD_TRAN_CREATE` | Start an explicit transaction.
    `static java.lang.String` | `CMD_TRAN_LIST` | List open transactions.
    `static java.lang.String` | `CMD_TRAN_MONITOR` | Monitor transactions.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `NetricsCmdStats()` | To keep Java happy, never use this constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `double` | `avg_full()` | The average full time for these commands completed during the report time period.
    `double` | `avg_overhead()` | The average overhead time for these commands completed during the report time period.
    `double` | `avg_proc()` | The average processing time for these commands completed during the report time period.
    `java.lang.String` | `cmd_name()` | Return the command name.
    `double` | `duration()` | Return the number of milliseconds covered by this report.
    `double` | `end_time()` | Return the end time of this report.
    `double` | `max_full()` | The maximum full time for this command during the report time period.
    `double` | `max_overhead()` | The maximum overhead time for this command during the report time period.
    `double` | `max_proc()` | The maximum processing time for this command during the report time period.
    `double` | `max_thru()` | The maximum throughput over a 1 minute period for commands completed during the report time period.
    `double` | `min_full()` | The minimum full time for this command during the report time period.
    `double` | `min_overhead()` | The minimum overhead time for this command during the report time period.
    `double` | `min_proc()` | The minimum processing time for this command during the report time period.
    `int` | `num_cmds()` | The number of these commands completed during the report time period.
    `double` | `start_time()` | Return the start time of this report.
    `java.lang.String` | `toString()` | Return report as a string.
    `double` | `tot_full()` | The total full time for all of these commands completed during the report time period.
    `double` | `tot_overhead()` | The total overhead time for all of these commands completed during the report time period.
    `double` | `tot_proc()` | The total processing time for all of these commands completed during the report time period.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### CMD_ALL

          public static final java.lang.String CMD_ALL

      Special "command" that means all commands.
      See Also:
        Constant Field Values

    - #### CMD_TBL_LOAD

          public static final java.lang.String CMD_TBL_LOAD

      The table load command.
      See Also:
        Constant Field Values

    - #### CMD_TBL_DELETE

          public static final java.lang.String CMD_TBL_DELETE

      The table delete command.
      See Also:
        Constant Field Values

    - #### CMD_TBL_MOVE

          public static final java.lang.String CMD_TBL_MOVE

      The table move (rename) command.
      See Also:
        Constant Field Values

    - #### CMD_TBL_CHECKPOINT

          public static final java.lang.String CMD_TBL_CHECKPOINT

      The table checkpoint command.
      See Also:
        Constant Field Values

    - #### CMD_TBL_RESTORE

          public static final java.lang.String CMD_TBL_RESTORE

      The table restore command.
      See Also:
        Constant Field Values

    - #### CMD_CHPT_STATS

          public static final java.lang.String CMD_CHPT_STATS

      Return information on last checkpoint (internal cmd only).
      See Also:
        Constant Field Values

    - #### CMD_TBL_LIST

          public static final java.lang.String CMD_TBL_LIST

      The table list (table statistics) command.
      See Also:
        Constant Field Values

    - #### CMD_IDX_LIST

          public static final java.lang.String CMD_IDX_LIST

      The index list command (for partitioned indexes).
      See Also:
        Constant Field Values

    - #### CMD_REC_GET

          public static final java.lang.String CMD_REC_GET

      The record get command.
      See Also:
        Constant Field Values

    - #### CMD_REC_ADD

          public static final java.lang.String CMD_REC_ADD

      The record add command.
      See Also:
        Constant Field Values

    - #### CMD_REC_DELETE

          public static final java.lang.String CMD_REC_DELETE

      The record delete command.
      See Also:
        Constant Field Values

    - #### CMD_REC_REPLACE

          public static final java.lang.String CMD_REC_REPLACE

      The record replace command.
      See Also:
        Constant Field Values

    - #### CMD_REC_UPDATE

          public static final java.lang.String CMD_REC_UPDATE

      The record update command.
      See Also:
        Constant Field Values

    - #### CMD_REC_RECNEXT

          public static final java.lang.String CMD_REC_RECNEXT

      Retrieve the next record from the table.
      See Also:
        Constant Field Values

    - #### CMD_THESAURUS_CREATE

          public static final java.lang.String CMD_THESAURUS_CREATE

      The thesaurus create command (includes weighted dict and combined).
      See Also:
        Constant Field Values

    - #### CMD_THESAURUS_DELETE

          public static final java.lang.String CMD_THESAURUS_DELETE

      The thesaurus delete command (includes weighted dict and combined).
      See Also:
        Constant Field Values

    - #### CMD_THESAURUS_LIST

          public static final java.lang.String CMD_THESAURUS_LIST

      The thesaurus list command (includes weighted dict and combined).
      See Also:
        Constant Field Values

    - #### CMD_CHARMAP_CREATE

          public static final java.lang.String CMD_CHARMAP_CREATE

      The Character Map Create command.
      See Also:
        Constant Field Values

    - #### CMD_CHARMAP_LIST

          public static final java.lang.String CMD_CHARMAP_LIST

      The Character Map List command.
      See Also:
        Constant Field Values

    - #### CMD_MODEL_CREATE

          public static final java.lang.String CMD_MODEL_CREATE

      The Learning Model create/load command.
      See Also:
        Constant Field Values

    - #### CMD_MODEL_DELETE

          public static final java.lang.String CMD_MODEL_DELETE

      The Learning Model delete command.
      See Also:
        Constant Field Values

    - #### CMD_MODEL_LIST

          public static final java.lang.String CMD_MODEL_LIST

      The Learning Model list command.
      See Also:
        Constant Field Values

    - #### CMD_MODEL_EVALUATE

          public static final java.lang.String CMD_MODEL_EVALUATE

      The Learning Model evaluate command.
      See Also:
        Constant Field Values

    - #### CMD_SEARCH

          public static final java.lang.String CMD_SEARCH

      The search (query) command.
      See Also:
        Constant Field Values

    - #### CMD_SCORE_RECORDS

          public static final java.lang.String CMD_SCORE_RECORDS

      Compute match score for a set of records.
      See Also:
        Constant Field Values

    - #### CMD_SVR_SHUTDOWN

          public static final java.lang.String CMD_SVR_SHUTDOWN

      The server shutdown command.
      See Also:
        Constant Field Values

    - #### CMD_SVR_NOOP

          public static final java.lang.String CMD_SVR_NOOP

      The server No-Op (do nothing) command.
      See Also:
        Constant Field Values

    - #### CMD_SVR_LOGON

          public static final java.lang.String CMD_SVR_LOGON

      The server turn Query logging on command.
      See Also:
        Constant Field Values

    - #### CMD_SVR_LOGOFF

          public static final java.lang.String CMD_SVR_LOGOFF

      The server turn Query logging off command.
      See Also:
        Constant Field Values

    - #### CMD_SVR_VERSION

          public static final java.lang.String CMD_SVR_VERSION

      The fetch server version info command.
      See Also:
        Constant Field Values

    - #### CMD_SVR_CMDSTATS

          public static final java.lang.String CMD_SVR_CMDSTATS

      The fetch command statistics command.
      See Also:
        Constant Field Values

    - #### CMD_TRAN_CREATE

          public static final java.lang.String CMD_TRAN_CREATE

      Start an explicit transaction.
      See Also:
        Constant Field Values

    - #### CMD_TRAN_COMMIT

          public static final java.lang.String CMD_TRAN_COMMIT

      Commit an explicit transaction.
      See Also:
        Constant Field Values

    - #### CMD_TRAN_ABORT

          public static final java.lang.String CMD_TRAN_ABORT

      Abort an explicit transaction.
      See Also:
        Constant Field Values

    - #### CMD_TRAN_LIST

          public static final java.lang.String CMD_TRAN_LIST

      List open transactions.
      See Also:
        Constant Field Values

    - #### CMD_TRAN_MONITOR

          public static final java.lang.String CMD_TRAN_MONITOR

      Monitor transactions.
      See Also:
        Constant Field Values

    - #### CMD_GATEWAY_CONFIG

          public static final java.lang.String CMD_GATEWAY_CONFIG

      Reload gateway configuration.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### NetricsCmdStats

          public NetricsCmdStats()

      To keep Java happy, never use this constructor

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Return report as a string. This formats the report into a multi line human readable report.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        human readable report as a string.

    - #### cmd_name

          public java.lang.String cmd_name()

      Return the command name. Returns the command name, the special value "<unknown>" if no command name was received.
      Returns:
        the command name.

    - #### start_time

          public double start_time()

      Return the start time of this report. Returns a value indicating the earliest time covered by this report. Time is measured in milliseconds from an arbitrary epic point. A value of -1.0 indicates no start time was given.
      Returns:
        the start time of this report.

    - #### end_time

          public double end_time()

      Return the end time of this report. Returns a value indicating the most recent time covered by this report. Time is measured in milliseconds from an arbitrary epic point. A value of -1.0 indicates no end time was given.
      Returns:
        the end time of this report.

    - #### duration

          public double duration()

      Return the number of milliseconds covered by this report. The total time span covered by this report in milliseconds. A value of -1.0 indicates the duration could not be calculated.
      Returns:
        the number of milliseconds covered by this report.

    - #### num_cmds

          public int num_cmds()

      The number of these commands completed during the report time period.
      Returns:
        number of commands completed during the report time period.

    - #### min_proc

          public double min_proc()

      The minimum processing time for this command during the report time period.
      Returns:
        The minimum processing time, in milliseconds, for this command during the report time period.

    - #### max_proc

          public double max_proc()

      The maximum processing time for this command during the report time period.
      Returns:
        The maximum processing time, in milliseconds, for this command during the report time period.

    - #### tot_proc

          public double tot_proc()

      The total processing time for all of these commands completed during the report time period.
      Returns:
        total processing time for all of these commands completed during the report time period.

    - #### avg_proc

          public double avg_proc()

      The average processing time for these commands completed during the report time period.
      Returns:
        average processing time for all of these commands completed during the report time period.

    - #### min_overhead

          public double min_overhead()

      The minimum overhead time for this command during the report time period.
      Returns:
        minimum overhead time for this command during the report time period.

    - #### max_overhead

          public double max_overhead()

      The maximum overhead time for this command during the report time period.
      Returns:
        maximum overhead time for this command during the report time period.

    - #### tot_overhead

          public double tot_overhead()

      The total overhead time for all of these commands completed during the report time period.
      Returns:
        total overhead time for all of these commands completed during the report time period.

    - #### avg_overhead

          public double avg_overhead()

      The average overhead time for these commands completed during the report time period.
      Returns:
        average overhead time for these commands completed during the report time period.

    - #### min_full

          public double min_full()

      The minimum full time for this command during the report time period.
      Returns:
        minimum overhead time for this command during the report time period.

    - #### max_full

          public double max_full()

      The maximum full time for this command during the report time period.
      Returns:
        maximum overhead time for this command during the report time period.

    - #### tot_full

          public double tot_full()

      The total full time for all of these commands completed during the report time period.
      Returns:
        total full time for all of these commands completed during the report time period.

    - #### avg_full

          public double avg_full()

      The average full time for these commands completed during the report time period.
      Returns:
        average full time for these commands completed during the report time period.

    - #### max_thru

          public double max_thru()

      The maximum throughput over a 1 minute period for commands completed during the report time period.
      Returns:
        maximum throughput over a 1 minute period for commands completed during the report time period.